//
//  NewsfeedViewController.swift
//  VKExt
//
//  Created programmist_NA on 25.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import Material
import Serrata

class NewsfeedViewController: UIBaseTableViewController, UIBaseViewControllerProtocol, UIBaseTableViewControllerProtocol, NewsfeedViewProtocol {
	var presenter: NewsfeedPresenterProtocol?
    private var feedViewModel = FeedViewModel.init(cells: [], footerTitle: nil)
    private var storiesViewModel = StoriesViewModel.init(cells: [], footerTitle: nil)
    private lazy var footerView = FooterView()
    var dataSource: [DataSourceItem] = []

    override func viewDidLoad() {
        super.viewDidLoad()
        prepareTabItem()
        self.view.backgroundColor = .adaptableWhite
        NewsfeedRouter.createModule(self)
        presenter?.start(request: .getNewsfeed)
        presenter?.start(request: .getStories)
        setupTable()
        // initialFooter()
    }
    
    fileprivate func prepareTabItem() {
        tabItem.title = "Новости"
        tabItem.setTabItemColor(.adaptableBlack, for: .selected)
        tabItem.setTabItemColor(.adaptableDarkGrayVK, for: .normal)
        tabItem.titleLabel?.font = GoogleSansFont.medium(with: 17)
    }
    
    func setupToolbar(title: String, subtitle: String, leftViews: [UIView]?, rightViews: [UIView]?) { }
    
    // Настройка таблицы
    func setupTable() {
        topOffset?.constant = getCommonInset(by: [.statusbar]) + 8
        mainTable.backgroundColor = .adaptableWhite
        mainTable.register(NewsFeedCell.self, forCellReuseIdentifier: NewsFeedCell.reuseId)
        mainTable.register(TableViewCell.self, forCellReuseIdentifier: TableViewCell.reuseId)
        mainTable.tableFooterView = footerView
        mainTable.keyboardDismissMode = .onDrag
        mainTable.allowsMultipleSelection = false
        mainTable.allowsMultipleSelectionDuringEditing = true
        mainTable.separatorStyle = .none
        mainTable.delegate = self
        mainTable.dataSource = self
        refreshControl.addTarget(self, action: #selector(refreshTable(_:)), for: .valueChanged)
    }
    
    func initialFooter() {
        self.view.addSubview(devView)
        devView.autoCenterInSuperview()
        devView.setup(page: "\"Новости\"", animation: "development")
        devView.devAnimationImage.loopMode = .playOnce
        devView.devAnimationImage.play()
    }
    
    @objc func refreshTable(_ sender: Any?) {
        presenter?.start(request: .getNewsfeed)
        presenter?.start(request: .getStories)
    }
    
    func reloadData() {
        mainTable.reloadData()
    }
    
    func displayData(viewModel: Newsfeed.Model.ViewModel.ViewModelData) {
        switch viewModel {
        case .displayStories(let storyViewModel):
            self.storiesViewModel = storyViewModel
            mainTable.reloadData()
            refreshControl.endRefreshing()
        case .displayNewsfeed(let feedViewModel):
            self.feedViewModel = feedViewModel
            footerView.setTitle(feedViewModel.footerTitle)
            mainTable.reloadData()
            refreshControl.endRefreshing()
        case .displayFooterLoader:
            footerView.setTitle("")
            footerView.showLoader()
        case .displayFooterError(message: let messageError):
            footerView.setTitle(messageError)
            mainTable.reloadData()
            refreshControl.endRefreshing()
        }
    }
    
    func scrollViewDidEndDragging(_ scrollView: UIScrollView, willDecelerate decelerate: Bool) {
        if scrollView.contentOffset.y > scrollView.contentSize.height / 1.1 {
            presenter?.start(request: Newsfeed.Model.Request.RequestType.getNextBatch)
        }
    }
    
    // MARK: NewsfeedCodeCellDelegate
    
    func revealPost(for cell: NewsFeedCell) {
        guard let indexPath = mainTable.indexPath(for: cell) else { return }
        let cellViewModel = feedViewModel.cells[indexPath.row]
        presenter?.start(request: Newsfeed.Model.Request.RequestType.revealPostIds(postId: cellViewModel.postId))
    }
    
    func likePost(for cell: NewsFeedCell) {
        guard let indexPath = mainTable.indexPath(for: cell) else { return }
        let count = feedViewModel.cells[indexPath.row].likes?.intValue
        let newCount = (count ?? 0) + 1
        feedViewModel.cells[indexPath.row].likes = newCount.stringValue
        feedViewModel.cells[indexPath.row].userLikes = 1
        cell.set(viewModel: feedViewModel.cells[indexPath.row])
        presenter?.onLikePost(request: Newsfeed.Model.Request.RequestType.like(postId: feedViewModel.cells[indexPath.row].postId, sourceId: feedViewModel.cells[indexPath.row].sourceId, type: feedViewModel.cells[indexPath.row].type))
    }
    
    func unlikePost(for cell: NewsFeedCell) {
        guard let indexPath = mainTable.indexPath(for: cell) else { return }
        let count = feedViewModel.cells[indexPath.row].likes?.intValue
        let newCount = (count ?? 0) - 1
        feedViewModel.cells[indexPath.row].likes = newCount == 0 ? "" : newCount.stringValue
        feedViewModel.cells[indexPath.row].userLikes = 0
        cell.set(viewModel: feedViewModel.cells[indexPath.row])
        presenter?.onLikePost(request: Newsfeed.Model.Request.RequestType.unlike(postId: feedViewModel.cells[indexPath.row].postId, sourceId: feedViewModel.cells[indexPath.row].sourceId, type: feedViewModel.cells[indexPath.row].type))
    }
    
    func openPhoto(for cell: NewsFeedCell, with url: String?) {
        guard let indexPath = mainTable.indexPath(for: cell) else { return }
        guard let selectedCell = mainTable.cellForRow(at: indexPath) as? NewsFeedCell else { return }
        guard let image = selectedCell.postImageView.image else { return }
        let slideLeafs = [SlideLeaf(image: image, imageUrlString: url, title: "Фотография 1 из 1", caption: "")]

        let slideImageViewController = SlideLeafViewController.make(leafs: slideLeafs, startIndex: indexPath.item, fromImageView: selectedCell.postImageView)
        slideImageViewController.modalPresentationStyle = .fullScreen
        present(slideImageViewController, animated: true)
    }
}
extension NewsfeedViewController: UITableViewDelegate, UITableViewDataSource, NewsFeedCellDelegate {
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return section == 0 ? 1 : feedViewModel.cells.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        if indexPath.section == 0 {
            let cell = tableView.dequeueReusableCell(withIdentifier: TableViewCell.reuseId, for: indexPath) as! TableViewCell
            let cellViewModels = storiesViewModel.cells
            cell.set(viewModel: cellViewModels)
            return cell
        } else {
            let cell = tableView.dequeueReusableCell(withIdentifier: NewsFeedCell.reuseId, for: indexPath) as! NewsFeedCell
            let cellViewModel = feedViewModel.cells[indexPath.row]
            cell.set(viewModel: cellViewModel)
            cell.delegate = self
            return cell
        }
    }
    
    func tableView(_ tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        let view = UIView(frame: CGRect(origin: .zero, size: CGSize(width: screenWidth, height: 8)))
        view.backgroundColor = .adaptableWhite
        return view
    }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        if section == 0 {
            return 10
        } else {
            return 5
        }
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 0 {
            return storiesViewModel.cells.count > 0 ? 104 : 0
        } else {
            let cellViewModel = feedViewModel.cells[indexPath.row]
            return cellViewModel.sizes.totalHeight
        }
    }
    
    func tableView(_ tableView: UITableView, estimatedHeightForRowAt indexPath: IndexPath) -> CGFloat {
        if indexPath.section == 0 {
            return storiesViewModel.cells.count > 0 ? 104 : 0
        } else {
            let cellViewModel = feedViewModel.cells[indexPath.row]
            return cellViewModel.sizes.totalHeight
        }
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return 2
    }
}
